Codeforces 545E Paths and Trees

来源:互联网 发布:广工数据库试卷 编辑:程序博客网 时间:2024/05/21 13:19

Codeforces 545E

Description:

Little girl Susie accidentally found her elder brother’s notebook. She has many things to do, more important than solving problems, but she found this problem too interesting, so she wanted to know its solution and decided to ask you about it. So, the problem statement is as follows.

Let’s assume that we are given a connected weighted undirected graph G = (V, E) (here V is the set of vertices, E is the set of edges). The shortest-path tree from vertex u is such graph G1 = (V, E1) that is a tree with the set of edges E1 that is the subset of the set of edges of the initial graph E, and the lengths of the shortest paths from u to any vertex to G and to G1 are the same.

You are given a connected weighted undirected graph G and vertex u. Your task is to find the shortest-path tree of the given graph from vertex u, the total weight of whose edges is minimum possible.

Input

The first line contains two numbers, n and m (1 ≤ n ≤ 3·105, 0 ≤ m ≤ 3·105) — the number of vertices and edges of the graph, respectively.

Next m lines contain three integers each, representing an edge — ui, vi, wi — the numbers of vertices connected by an edge and the weight of the edge (ui ≠ vi, 1 ≤ wi ≤ 109). It is guaranteed that graph is connected and that there is no more than one edge between any pair of vertices.

The last line of the input contains integer u (1 ≤ u ≤ n) — the number of the start vertex.

Output

In the first line print the minimum total weight of the edges of the tree.

In the next line print the indices of the edges that are included in the tree, separated by spaces. The edges are numbered starting from 1 in the order they follow in the input. You may print the numbers of the edges in any order.

If there are multiple answers, print any of them.

Sample test(s)

input

3 3
1 2 1
2 3 1
1 3 2
3

output

2
1 2

input

4 4
1 2 1
2 3 1
3 4 1
4 1 2
4

output

4
2 3 4

Note

In the first sample there are two possible shortest path trees:

with edges 1 – 3 and 2 – 3 (the total weight is 3);
with edges 1 – 2 and 2 – 3 (the total weight is 2);
And, for example, a tree with edges 1 – 2 and 1 – 3 won’t be a shortest path tree for vertex 3, because the distance from vertex 3 to vertex 2 in this tree equals 3, and in the original graph it is 1.


简单的贪心+最短路
贪心其实比较简单,但是不怎么好想。
但话说回来也不难。。
就是在SPFA求最短路的时候维护一个Pre[],表示第i个点是由哪条边过来的。
以第一个样例为例,第一层BFS时会有两种选择3->1&3->2,接下来可以由1->2||2->1但是我们选择后者,这是因为3->2+2->1的距离恰好等于3->1的距离。这时候我们就可以把pre[1]的编号变为1->2的边所在的编号。这就是贪心的策略。
然后就是输出的时候要注意由于加的是双向边。所以要记得/2;

Code:

#include <stdio.h>#include <string.h>#include <queue>#define MAXN 350000using namespace std;typedef long long ll;struct node{    ll from;    ll to;    ll next;    ll val;}edge[MAXN<<1];ll n,m,cnt,src,ans;ll head[MAXN],visit[MAXN],dis[MAXN],pre[MAXN];  //for i_th poll : pre[i] _ th edge_pathvoid init(){    memset(head,-1,sizeof(head));    cnt=0;}void addedge(ll from,ll to,ll val){    edge[++cnt].from=from;    edge[cnt].to=to;    edge[cnt].val=val;    edge[cnt].next=head[from];    head[from]=cnt;}void SPFA(){    memset(dis,0x3f,sizeof(dis));    memset(visit,0,sizeof(visit));    visit[src]=1;    dis[src]=0;    queue<int>Q;    Q.push(src);    while(!Q.empty())    {        ll u=Q.front();        Q.pop();        visit[u]=0;        for(ll i=head[u];i!=-1;i=edge[i].next)        {            ll v=edge[i].to;            if(dis[v]>dis[u]+edge[i].val)            {                dis[v]=dis[u]+edge[i].val;                pre[v]=i;                if(!visit[v])                {                    visit[v]=1;                    Q.push(v);                }            }            else if(dis[v]==dis[u]+edge[i].val&&edge[i].val<edge[pre[v]].val)   //Greedy             {                pre[v]=i;               }        }                                  }}int main(){    init();    scanf("%I64d%I64d",&n,&m);    for(ll i=1;i<=m;i++)    {        ll a,b,c;        scanf("%I64d%I64d%I64d",&a,&b,&c);        addedge(a,b,c);        addedge(b,a,c);    }    scanf("%I64d",&src);    SPFA();    for(ll i=1;i<=n;i++)    {        if(pre[i])ans+=(edge[pre[i]].val);    }    printf("%I64d\n",ans);    for(ll i=1;i<=n;i++)    {        if(pre[i])printf("%I64d ",(pre[i]+1)/2);    }    return 0;}
0 0
原创粉丝点击